''' (c) 2008 by the GunGame Coding Team

    Title: gg_cheap_equip
    Version: 1.0.0
    Description: Custom addon.
    '''

# ==============================================================================
#   IMPORTS
# ==============================================================================
# EventScripts imports
import es
import gamethread

# GunGame imports
import gungamelib

# ==============================================================================
#   ADDON REGISTRATION
# ==============================================================================
# Register this addon with EventScripts
info = es.AddonInfo()
info.name     = '!equip command to re-equip you at any time for GunGame: Python'
info.version  = '1.0.0'
info.url      = 'http://forums.gungame5.com/viewtopic.php?f=17&t=238'
info.basename = 'gungame/custom_addons/gg_cheap_equip'
info.author   = 'Sc0pE'

es.ServerVar('gg_cheap_equip_ver', info.version).makepublic()

# ==============================================================================
#   GAME EVENTS
# ==============================================================================
def load():
    # Register this addon with GunGame
    gg_cheap_equip = gungamelib.registerAddon('gg_cheap_equip')
    gg_cheap_equip.setDisplayName('GG Cheap Equip')
    
    gg_cheap_equip.registerPublicCommand(gungamelib.getVariableValue('gg_cheap_equip_command'), giveNewWeapon)

def unload():
    # Unregister this addon with GunGame
    gungamelib.unregisterAddon('gg_cheap_equip')

# ==============================================================================
#   HELPER FUNCTIONS
# ==============================================================================
def giveNewWeapon(userid):
    userid = int(userid)
    gungamePlayer = gungamelib.getPlayer(userid)
    
    if gungamelib.isDead(userid):
        return
        
    if gungamelib.isSpectator(userid):
        return
    
    gungamePlayer.stripPlayer()
    
    # Only delay if we are on linux
    if gungamelib.getOS() == 'posix':
        gamethread.delayed(0, delayedGiveNewWeapon, (userid))
    else:
        gungamePlayer.giveWeapon()

def delayedGiveNewWeapon(userid):
    if gungamelib.isDead(userid):
        return
    
    if gungamelib.isSpectator(userid):
        return
    
    gungamePlayer = gungamelib.getPlayer(userid)
    gungamePlayer.giveWeapon()